 list      p=16F84A
 #include <p16F84A.inc>

 __CONFIG _HS_OSC & _WDT_OFF & _PWRTE_ON & _CP_OFF

	ORG 00h		; 00hԒnvOZbg

;******************************
; 	 WX^ݒ
;******************************

T1	EQU	0Ch
T2	EQU	0Dh
T3	EQU	0Eh
CNT1	EQU	0Fh
CNT2	EQU	10h
CNT3	EQU	11h

	BSF		STATUS, RP0	; BANK 1ɐؑւ
	MOVLW 	B'00011'	; RA0,RA1͂ɐݒ  WWX^
	MOVWF	TRISA		; WWX^  A|[g o͐ݒ
	CLRF	TRISB		; B|[gSďo͂ɐݒ
	BCF		STATUS, RP0	; BANK 0ɐؑւ

;******************************
;  JE^l@ݒ
;******************************

	MOVLW	D'8'		; 8  WWX^
	MOVWF	CNT1		; WWX^  CNT1
	MOVLW	D'4'		; 4  WWX^
	MOVWF	CNT2		; WWX^  CNT2
	MOVLW	D'2'		; 2  WWX^
	MOVWF	CNT3		; WWX^  CNT3

;******************************
;  XCb`(SW0 ON?)
;******************************

MAIN
	BTFSS 	PORTA, 0	; RA01Ȃ玟̍sXLbv
	GOTO	CK_SW_1		; (SW0 ON)
	GOTO	CK_SW_2		; (SW0 OFF)

;******************************
;  XCb`(SW1 ON?)
;******************************

CK_SW_1
	BTFSS 	PORTA, 1	; RA11Ȃ玟̍sXLbv
	GOTO 	CASE4		; (SW0 ON) (SW1 ON)
	GOTO 	CASE1		; (SW0 ON) (SW1 OFF)

;******************************
;  XCb`(SW1 ON?)
;******************************

CK_SW_2
	BTFSS 	PORTA, 1	; RA11Ȃ玟̍sXLbv
	GOTO 	CASE2		; (SW0 OFF) (SW1 ON)
	GOTO 	CASE3		; (SW0 OFF) (SW1 OFF)


;**********************************
; Xs[J312.5Hz (SW0 ON) (SW1 OFF)
;**********************************

CASE1
	CALL	TIM04
	DECFSZ	CNT1,F		; CNT1|1CNT1@ʂ0Ȃ玟̍sXLbv
	GOTO	MAIN		; (CNT10)
	CALL	SPK_ON		; (CNT10)
	MOVLW	D'8'		; 8  WWX^
	MOVWF	CNT1		; WWX^  CNT1
	GOTO	MAIN		;

;**********************************
; Xs[J625Hz (SW0 OFF) (SW1 ON)
;**********************************

CASE2
	CALL	TIM04
	DECFSZ	CNT2,F		; CNT2|1CNT2@ʂ0Ȃ玟̍sXLbv
	GOTO	MAIN		; (CNT20)
	CALL	SPK_ON		; (CNT20)
	MOVLW	D'4'		; 4  WWX^
	MOVWF	CNT2		; WWX^  CNT2
	GOTO	MAIN		;

;**********************************
; Xs[J It (SW0 OFF) (SW1 OFF)
;**********************************

CASE3
	MOVLW	B'00000000'	; LEDf[^ݒ
	MOVWF	PORTB		; LED
	GOTO	MAIN		;

;**********************************
; LXs[J1250Hz (SW0 ON) (SW1 ON)
;**********************************

CASE4
	CALL	TIM04
	DECFSZ	CNT3,F		; CNT3|1CNT3@ʂ0Ȃ玟̍sXLbv
	GOTO	MAIN		; (CNT30)
	CALL	SPK_ON		; (CNT30)
	MOVLW	D'2'		; 2  WWX^
	MOVWF	CNT3		; WWX^  CNT3
	GOTO	MAIN		;

;**********************************
; Xs[J@I
;**********************************

SPK_ON
	MOVLW 	B'00010000' 	; XORWFp̔]rbg 1̂Ƃ낾]
	XORWF	PORTB, F		; f[^𔽓](ONOFF)
	RETURN


;******************************
;	  0.4msec ^C}
;******************************

TIM04
	MOVLW		D'250'	
	MOVWF		T1
TIMLOOP1
	NOP
	DECFSZ		T1, F
	GOTO		TIMLOOP1	; 1+1+(249~4)+3=1001TCN
	RETURN					; 1001+2=1003TCN
	
;******************************
;	  100msec ^C}
;******************************

TIM100
	MOVLW		D'250'	
	MOVWF		T2
TIMLOOP2
	CALL		TIM04
	DECFSZ		T2, F
	GOTO		TIMLOOP2	; 0.4msec~250=100msec
	RETURN

;******************************
;	  500msec ^C}
;******************************

TIM500
	MOVLW		D'5'	
	MOVWF		T3
TIMLOOP3
	CALL		TIM100
	DECFSZ		T3, F
	GOTO		TIMLOOP3	; 100msec~5=500msec
	RETURN

 END
